
  <!DOCTYPE html>
  <html>
    <head>
      <title>MultiSelect.tsx</title>
      <link href="https://cdn.jsdelivr.net/npm/semantic-ui@2.4.2/dist/semantic.min.css" type="text/css" rel="stylesheet">
      <script src="https://cdnjs.cloudflare.com/ajax/libs/codemirror/5.58.2/codemirror.min.js" type="text/javascript" charset="utf-8"></script>
<script src="https://cdnjs.cloudflare.com/ajax/libs/codemirror/5.58.2/mode/javascript/javascript.min.js" type="text/javascript" charset="utf-8"></script>
<link href="https://cdnjs.cloudflare.com/ajax/libs/codemirror/5.58.2/codemirror.min.css" type="text/css" rel="stylesheet">
<script src="../../../../assets/source-file.js" type="text/javascript" charset="utf-8"></script>
<link href="../../../../assets/source-file.css" type="text/css" rel="stylesheet">
    </head>
    <body>
    <div style="margin-top:3em" class="ui container"><h1 class="ui header"><a href="../../../../index.html">TypeScript coverage report</a></h1><table style="margin-top:2em" class="ui celled table"><thead class=""><tr class=""><th class="">Filename</th><th class="">Percent</th><th class="">Threshold</th><th class="">Total</th><th class="">Covered</th><th class="">Uncovered</th></tr></thead><tbody class=""><tr class="positive"><td class="">src/components/MultiSelect/MultiSelect.tsx</td><td class="">97.89%</td><td class="">80%</td><td class="">142</td><td class="">139</td><td class="">3</td></tr></tbody></table><textarea id="editor" readonly="" style="margin-top:3em">import React, { useCallback, useEffect, useMemo, useState } from &#x27;react&#x27;;
import clsx from &#x27;clsx&#x27;;

import s from &#x27;./MultiSelect.module.scss&#x27;;
import { ReactComponent as CaretDown } from &#x27;../Table/assets/caret-down.svg&#x27;;

export interface MultiSelectProps&lt;Key extends string = string&gt; {
  placeholder?: string;
  className?: string;
  value: Key[];
  onChange: (value: Key[]) =&gt; void;
  options: { value: Key; label: string }[];
}

export const MultiSelect: React.FC&lt;MultiSelectProps&gt; = ({
  placeholder,
  className,
  value,
  onChange,
  options
}) =&gt; {
  const selectedValues = useMemo(
    () =&gt;
      options.filter((opt) =&gt; value.includes(opt.value)).map((o) =&gt; o.label),
    [value, options]
  );
  const [isOpen, onChangeOpen] = useState(false);
  const toggle = useCallback(() =&gt; onChangeOpen((s) =&gt; !s), []);
  const [ref, setRef] = useState&lt;HTMLDivElement | null&gt;(null);
  useEffect(() =&gt; {
    if (ref) {
      const handler = (ev: any) =&gt; {
        if (!ref.contains(ev.target as HTMLElement)) {
          onChangeOpen(false);
        }
      };
      window.addEventListener(&#x27;click&#x27;, handler);
      return () =&gt; window.removeEventListener(&#x27;click&#x27;, handler);
    }
  }, [ref]);
  return (
    &lt;div ref={setRef} className={s.MultiSelect}&gt;
      &lt;div className={s.MultiSelect__name} onClick={toggle}&gt;
        &lt;div&gt;
          {selectedValues.length &gt; 0 ? selectedValues.join(&#x27;, &#x27;) : placeholder}
        &lt;/div&gt;
        &lt;CaretDown /&gt;
      &lt;/div&gt;
      &lt;div
        className={clsx(
          s.MultiSelect__options,
          isOpen &amp;&amp; s.MultiSelect__options_open
        )}
      &gt;
        {options.map((option) =&gt; {
          const isSelected = value.includes(option.value);
          return (
            &lt;div
              key={option.value}
              className={clsx(
                s.MultiSelect__option,
                isSelected &amp;&amp; s.MultiSelect__option_selected
              )}
              onClick={() =&gt; {
                if (isSelected) {
                  onChange(value.filter((v) =&gt; v !== option.value));
                } else {
                  onChange(value.concat(option.value));
                }
              }}
            &gt;
              {option.label}
            &lt;/div&gt;
          );
        })}
      &lt;/div&gt;
    &lt;/div&gt;
  );
};
</textarea><pre id="annotations" style="display:none">[{&quot;file&quot;:&quot;src/components/MultiSelect/MultiSelect.tsx&quot;,&quot;line&quot;:31,&quot;character&quot;:23,&quot;text&quot;:&quot;ev&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/components/MultiSelect/MultiSelect.tsx&quot;,&quot;line&quot;:32,&quot;character&quot;:26,&quot;text&quot;:&quot;ev&quot;,&quot;kind&quot;:1},{&quot;file&quot;:&quot;src/components/MultiSelect/MultiSelect.tsx&quot;,&quot;line&quot;:32,&quot;character&quot;:29,&quot;text&quot;:&quot;target&quot;,&quot;kind&quot;:1}]</pre></div>
    <p class="footer-text">TypeScript Coverage Report generated by <a href="https://github.com/plantain-00/type-coverage">type-coverage</a> and <a href="https://github.com/alexcanessa/typescript-coverage-report">typescript-coverage-report</a> at Tue, 05 Oct 2021 23:09:04 GMT</p>
    </body>
  </html>
  